#include "mojeokno.h"
#include "ui_mojeokno.h"

void setupTable (QTableWidget *t)
{
    t->setColumnCount(8);
    t->setRowCount(8);

    int h = t->rowHeight (0);
    for (int i = 0; i <= 7; i++)
        t->setColumnWidth (i, h);

    QStringList list;
    for (int i = 0; i <= 7; i++)
        list << QString ('a'+i);
    t->setHorizontalHeaderLabels(list);

    list.clear ();
    for (int i = 0; i <= 7; i++)
        list << QString::number (8-i);
    t->setVerticalHeaderLabels(list);
}

MojeOkno::MojeOkno(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MojeOkno)
{
    ui->setupUi(this);
    setupTable (ui->tableWidget);
    setupTable (ui->traceWidget);
}

MojeOkno::~MojeOkno()
{
    delete ui;
}

QTableWidgetItem * v [8][8];

void MojeOkno::skoc(int x0, int y0, int n,
                    int x, int y)
{
    if (x >= 0 && x <= 7 &&
        y >= 0 && y <= 7 && n <= limit)
    {
        if (z[x][y] == -1 || z[x0][y0] + 1 < z[x][y])
        {
            if (n==0)
                z[x][y] = 0;
            else
                z[x][y] = z[x0][y0] + 1;

        // QTableWidgetItem * p = v [x][y];
        // if (p == NULL)
        // {
            QString s = QString::number (n);
            QString t = ('a'+x0) + QString::number (y0+1);
            if (n == 0) t = "zacatek";

            QColor c = QColor::fromHsv((n*20)%360, 200, 255);

            QString q = QString::number (n) + " : " + t + " -> " +
                QString ('a'+x) + QString::number (y+1);

            MyNode * node = new MyNode;
            node->setText(0, q);
            node->setTextColor (0, c);

            for (int i = 0; i <= 7; i++)
                for (int j = 0; j <= 7; j++)
                {
                    QTableWidgetItem * p = ui->tableWidget->item(i,j);
                    if (p == NULL) p = new QTableWidgetItem;
                    node->pole[i][j] = p->clone ();
                }

            if (branch == NULL)
               ui->treeWidget->addTopLevelItem (node);
            else
               branch->addChild (node);

            QTreeWidgetItem * save = branch;
            branch = node;

            QTableWidgetItem * p = new QTableWidgetItem;
            p->setText (s);
            p->setToolTip (t);
            p->setBackgroundColor (c);
            p->setTextColor(QColor ("red"));
            ui->tableWidget->setItem(y, x, p);
            // assert (v[x][y] == NULL);
            v[x][y] = p;

            skoc (x, y, n+1, x+2, y+1);
            skoc (x, y, n+1, x-2, y+1);
            skoc (x, y, n+1, x+2, y-1);
            skoc (x, y, n+1, x-2, y-1);

            skoc (x, y, n+1, x+1, y+2);
            skoc (x, y, n+1, x-1, y+2);
            skoc (x, y, n+1, x+1, y-2);
            skoc (x, y, n+1, x-1, y-2);

            branch = save;
        }
    }
}

void MojeOkno::on_actionRun_triggered()
{
    for (int i = 0; i <= 7; i++)
        for (int j = 0; j <= 7; j++)
            v[i][j] = NULL;

    for (int i = 0; i <= 7; i++)
        for (int j = 0; j <= 7; j++)
            z[i][j] = -1;

    ui->tableWidget->clearContents ();
    ui->treeWidget->clear ();

    limit = ui->horizontalSlider->value();
    int x = ui->spinBoxX->value();
    int y = ui->spinBoxY->value();

    branch = NULL;
    skoc (0, 0, 0, x, y);
}

void MojeOkno::on_treeWidget_itemClicked(QTreeWidgetItem *item, int column)
{
   MyNode * node = dynamic_cast <MyNode *> (item);
   if (node != NULL)
   {
       for (int i = 0; i <= 7; i++)
           for (int j = 0; j <= 7; j++)
           {
               QTableWidgetItem * p = node->pole[i][j];
               ui->traceWidget->setItem(i, j, p->clone ());
           }
   }
}
